﻿<%@ Control Language="C#" AutoEventWireup="true"  %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<%@ Register Assembly="BlazerStudios.CalendarWebpart, Version=1.0.0.0, Culture=neutral, PublicKeyToken=b2c41fc8c1d22f4a" Namespace="BlazerStudios.CalendarWebpart" TagPrefix="test" %>
<script runat="server">




//    protected CalendarWebPart calWebPart;

    private string currentSite;
    //public string CurrentSite
    //{
    //    get { return currentSite; }
    //    set { currentSite = value; }
    //}

    private int numberOfEvents = 3;
    //public int NumberOfEvents
    //{
    //    get { return numberOfEvents; }
    //    set { numberOfEvents = value; }
    //}

    private string calendarName;
    //public string CalendarName
    //{
    //    get { return calendarName; }
    //    set { calendarName = value; }
    //}

    private string calendarTodayColor = "";

    private bool dayselected = false;
    private DateTime dateSelected = DateTime.MinValue;
    protected void Page_PreRender(object sender, EventArgs e)
    {
        
        
        // Load properties;
        // make web part implement an interface and check if parent is typeof() the interface
        // Step 1: Get Ref to WebPart
        CalendarWebpart calWebPart = null;
        if (Parent is CalendarWebpart)
            calWebPart = (CalendarWebpart)Parent;
        
        // Step 2: Load WebPart's properties
        if(calWebPart != null)
        {
            currentSite = calWebPart.CurrentSite;
            calendarName = calWebPart.ListName;
            numberOfEvents = calWebPart.EventNumber;
            calendarTodayColor = calWebPart.TodayColor;
        }

        if (calendarName == "")
        {
            lblOpenToolpan.Text = "<br>&nbsp;Please " + "<a href=\"javascript:MSOTlPn_ShowToolPane2Wrapper('Edit', this, '" + this.Parent.ID + "')\">open the tool pane</a>" + " to configure this webpart.<br><br>";
            pnlMain.Visible = false;
            lblOpenToolpan.Visible = true;
        }
        else
        {
            lblOpenToolpan.Visible = false;
            pnlMain.Visible = true;
            // Step 3: Configure Calendar
            SPWeb curWeb = null;
            SPList calendarList = null;
            if (!string.IsNullOrEmpty(currentSite))
            {
                curWeb = SPContext.Current.Site.OpenWeb(currentSite);
            }
            if ((!string.IsNullOrEmpty(calendarName)) && (curWeb != null))
            {
                calendarList = curWeb.Lists[calendarName];
            }
            if (calendarList != null)
            {
                // set url for link leading to calendar's default view
                calLibUrl.NavigateUrl = calendarList.DefaultViewUrl;

                LoadCalendarDates(calendarList);

                SPQuery query = new SPQuery();
                query.ExpandRecurrence = true;
                query.Query = "<OrderBy><FieldRef Name='EventDate' Ascending='True'/></OrderBy><Where><Geq><FieldRef Name='EventDate'/><Value Type='DateTime'>" + DateTime.Now.ToString("yyyy-MM-ddTHH\\:mm\\:ssZ") + "</Value></Geq></Where>";

                SPListItemCollection calendarItems = calendarList.GetItems(query);

                for (int i = 0; i < calendarItems.Count; i++)
                {
                    if (i > numberOfEvents - 1) break;

                    SPListItem calendarItem = calendarItems[i];

                    Label date = new Label();
                    date.Text = "<br><br>" + Convert.ToDateTime(calendarItem["EventDate"]).ToShortDateString() + " - ";
                    date.Font.Size = new FontUnit("7pt");
                    date.Font.Italic = true;
                    linksDiv.Controls.Add(date);

                    HyperLink lnk = new HyperLink();
                    lnk.NavigateUrl = calendarList.DefaultViewUrl.Substring(0, calendarList.DefaultViewUrl.LastIndexOf("/") + 1) + "DispForm.aspx?ID=" + calendarItem.ID;
                    lnk.Text = calendarItem["Title"].ToString();
                    linksDiv.Controls.Add(lnk);
                }
            }
            Calendar1.CellPadding = 5;
            Calendar1.CellSpacing = 2;
            Calendar1.BorderColor = System.Drawing.Color.LightGray;
            Calendar1.TitleStyle.BackColor = System.Drawing.ColorTranslator.FromHtml("#f2f2f2");
            Calendar1.TitleStyle.ForeColor = System.Drawing.ColorTranslator.FromHtml("#6c6b6b");
            Calendar1.DayHeaderStyle.ForeColor = System.Drawing.ColorTranslator.FromHtml("#818080");
            Calendar1.DayStyle.ForeColor = System.Drawing.ColorTranslator.FromHtml("#9f9e9e");
            Calendar1.OtherMonthDayStyle.ForeColor = System.Drawing.ColorTranslator.FromHtml("#CCCCCC");
            Calendar1.OtherMonthDayStyle.BackColor = System.Drawing.ColorTranslator.FromHtml("#f2f2f2");
            //Calendar1.SelectionChanged += new System.EventHandler(Calendar1_SelectionChanged);
            Calendar1.TodayDayStyle.ForeColor = System.Drawing.ColorTranslator.FromHtml("#bbbbbb");
            Calendar1.TodayDayStyle.BackColor = System.Drawing.ColorTranslator.FromHtml(calendarTodayColor);
            Calendar1.TodayDayStyle.Font.Bold = true;
            Calendar1.TodayDayStyle.Font.Underline = true;

            if (dayselected)
            {
                Response.Redirect(calendarList.DefaultViewUrl + "?CalendarDate=" + dateSelected.ToShortDateString() + "&CalendarPeriod=Day");
            }
        }
    }

    private void LoadCalendarDates(SPList calendarList)
    {
        if (calendarList == null) return;

        for (int i = 0; i < calendarList.ItemCount; i++ )
        {
            SPListItem item = calendarList.Items[i];
            DateTime dt = (DateTime)item["EventDate"];
            Calendar1.SelectedDates.Add(dt);
        }
    }

    protected void Calendar1_SelectionChanged(object sender, EventArgs e)
    {
        //SPWeb curWeb = null;
        //SPList calendarList = null;
        //if (currentSite != "")
        //{
        //    curWeb = SPContext.Current.Site.OpenWeb(currentSite);
        //}
        //if (calendarName != "" && curWeb != null)
        //{
        //    calendarList = curWeb.Lists[calendarName];
        //    Response.Redirect(calendarList.DefaultViewUrl + "?CalendarDate=" + Calendar1.SelectedDate.ToShortDateString() + "&CalendarPeriod=Day");
        //}
        dayselected = true;
        dateSelected = Calendar1.SelectedDate;
    }
    
</script>
<asp:Label runat="server" ID="lblOpenToolpan"></asp:Label>
<asp:Panel runat="server" ID="pnlMain">
<div>
    <div style="padding-bottom:10px; margin-left:15px; margin-right: 15px; text-align:left; border-bottom:solid 1px #cccccc; " runat="server" id="linksDiv">
    </div>
</div>
<div style="margin-top:5px; margin-bottom:5px" runat="server" id="calDiv">
   
            <table style="width:100%" >
                <tr>
                    <td style="width:100%" align="center" >
                        <asp:Calendar ID="Calendar1" runat="server" OnSelectionChanged="Calendar1_SelectionChanged"></asp:Calendar>
                    </td>
                </tr>
            </table>
    <br />
    </div>
    <table cellpadding=0 cellspacing=0 border=0>
        <tr><td class="ms-addnew2" style="padding-bottom: 3px; padding-left:2px;">
        <img src="/_layouts/images/rect.gif" />&nbsp;<asp:HyperLink CssClass="ms-addnew" runat="server" ID="calLibUrl" NavigateUrl="" Text="View Calendar" />
        </td>
        </tr>
    </table>
</asp:Panel>

