using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.ComponentModel;
using System.Web.UI.WebControls;

namespace BlazerStudios.CalendarWebpart
{
    [Guid("aad700c1-99b3-4478-80ed-97c31a56ce78")]
    public class CalendarWebpart : Microsoft.SharePoint.WebPartPages.WebPart
    {
        private bool _error = false;
        private string _myProperty = null;


        private Control _childControl = null;
        private string _userControlVirtualPath = "/_layouts/BlazerStudios.CalendarWebpart.ascx";
        private string currentSite = "/";
        private string listName = string.Empty;
        private int eventNumber = 3;
        private string todaycolor = "#d6e8ff";
        private string _errMessage = string.Empty;

        [Personalizable(),
        Category("Calendar Settings"),
        DefaultValue(""),
        WebBrowsable(false),
        WebDisplayName("User Control Virtual Path"),
        WebDescription("User Control Virtual Path")]
        public string UserControlVirtualPath
        {
            get { return _userControlVirtualPath; }
            set { _userControlVirtualPath = value; }
        }

        [Personalizable(),
        Category("Calendar Settings"),
        DefaultValue(""),
        WebBrowsable(true),
        WebDisplayName("SharePoint Site, example \"/\" for root site"),
        WebDescription("SharePoint Site")]
        public string CurrentSite
        {
            get { return currentSite; }
            set { currentSite = value; }
        }

        [Personalizable(),
        Category("Calendar Settings"),
        DefaultValue(""),
        WebBrowsable(true),
        WebDisplayName("List Name, example \"Company Calendar\""),
        WebDescription("List Name")]
        public string ListName
        {
            get { return listName; }
            set { listName = value; }
        }


        [Personalizable(),
        Category("Calendar Settings"),
        DefaultValue(""),
        WebBrowsable(true),
        WebDisplayName("Today Color"),
        WebDescription("Today Color")]
        public string TodayColor
        {
            get { return todaycolor; }
            set { todaycolor = value; }
        }

        [Personalizable(),
        Category("Calendar Settings"),
        DefaultValue(""),
        WebBrowsable(true),
        WebDisplayName("Event Number"),
        WebDescription("Event Number")]
        public int EventNumber
        {
            get { return eventNumber; }
            set { eventNumber = value; }
        }



        public CalendarWebpart()
        {
            this.ExportMode = WebPartExportMode.All;
        }

        /// <summary>
        /// Create all your controls here for rendering.
        /// Try to avoid using the RenderWebPart() method.
        /// </summary>
        protected override void CreateChildControls()
        {
            
        }

        private void loadcontrol()
        {
            if (!_error)
            {
                try
                {

                    // Your code here...
                    //if (ListName != "")
                    //{
                    if (_childControl != null) return;
                        _childControl = Page.LoadControl(_userControlVirtualPath);

                    if (_childControl != null)
                        Controls.AddAt(0, _childControl as Control);
                    //}
                    //else
                    //{
                    //    Label lbl2 = new Label();
                    //    lbl2.Text = "<br>&nbsp;Please " + "<a href=\"javascript:MSOTlPn_ShowToolPane2Wrapper('Edit', this, '" + this.ID + "')\">open the tool pane</a>" + " to configure this webpart.<br><br>";
                    //    this.Controls.Add(lbl2);
                    //}


                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
            }
        }

        protected override void OnInit(EventArgs e)
        {
            //base.OnInit(e);
            loadcontrol();
        }

        /// <summary>
        /// Ensures that the CreateChildControls() is called before events.
        /// Use CreateChildControls() to create your controls.
        /// </summary>
        /// <param name="e"></param>
        protected override void OnLoad(EventArgs e)
        {
            if (!_error)
            {
                try
                {
                    base.OnLoad(e);
                    //this.EnsureChildControls();

                    // Your code here...
                }
                catch (Exception ex)
                {
                    HandleException(ex);
                }
            }
        }

        protected override void OnPreRender(EventArgs e)
        {
            //this.Controls.Clear();
            //loadcontrol();
        }

        /// <summary>
        /// Clear all child controls and add an error message for display.
        /// </summary>
        /// <param name="ex"></param>
        private void HandleException(Exception ex)
        {
            this._error = true;
            this.Controls.Clear();
            this.Controls.Add(new LiteralControl(ex.Message));
        }
    }
}
